import { SObjectItem, SImageItem, SGraphItem, STextItem } from "@saga-web/graph/lib";
import { ItemOrder } from "@saga-web/big/lib";
import { SColor, SPainter, SRect } from "@saga-web/draw/lib";
import { SMouseEvent } from "@saga-web/base/lib";
export class SEquipmentItem extends SObjectItem {
    // img对象
    img: SImageItem = new SImageItem(this);
    textArr: STextItem[] = [];
    /**
     *
     * @param parent 父类
     * @param textInfo  需要展示的节点信息
     */
    constructor(parent: SGraphItem | null, textInfo?: object) {
        super(parent);
        console.log(textInfo);
        // this.img.url = `http://adm.sagacloud.cn:8080/doc/assets/img/logo.png`;
        this.img.url = `http://localhost:8091/serve/topology-wanda/Picture/query/1bf10f5d64aa41ffb136757f3b96f9d1`;
        this.img.width = 50;
        this.img.height = 50;
        this.width = 100;
        this.height = 100;

        this.moveable = false;
        this.zOrder = ItemOrder.textOrder;
        this.textArr = [];
        // 有信息点信息时,绘制信息点信息
        if (textInfo) {
            let index = 0;
            for (let key in textInfo) {
                let textItem = new STextItem(this);
                textItem.moveable = true;
                textItem.backgroundColor = SColor.White;
                textItem.font.size = 14;
                // 偏移二分之一文本高度
                // textItem.moveTo(17, -(textItem.height * 0.5));
                textItem.moveTo(17, index * 20 - 10);
                // @ts-ignore
                textItem.text = `${key} : ${textInfo[key]}`;
                this.textArr.push(textItem);
                index++;
            }
        }
    }

    /**
     * 宽高发生变化
     *
     * @return  SRect   所有子对象的并集
     * */
    boundingRect(): SRect {
        //  return new SRect(-this.width / 2, -this.height / 2, this.width, this.height);
        let rect = this.img.boundingRect().adjusted(this.img.pos.x, this.img.pos.y, 0, 0);
        if (this.textArr.length) {
            for (let text of this.textArr) {
                rect = rect.unioned(text.boundingRect().adjusted(text.pos.x, text.pos.y, 0, 0));
            }
        }
        return rect.adjusted(-5, -5, 10, 10);
    } // Function boundingRect()

    /**
     * Item绘制操作
     *
     * @param   painter painter对象
     */
    onDraw(painter: SPainter): void {
        painter.pen.lineWidth = painter.toPx(1);
        painter.pen.color = SColor.Black;
        painter.brush.color = SColor.White;
        painter.drawRect(this.boundingRect());
    } // Function onDraw()
}
